Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.thoughtworks.selenium
Class DefaultSelenium

    java.lang.Object
      com.thoughtworks.selenium.DefaultSelenium

All Implemented Interfaces:
  Selenium

    public class DefaultSelenium

extends java.lang.Object
implements Selenium

The default implementation of the Selenium interface; end users will primarily interact with this object.

Field Summary
`protected CommandProcessor` | `commandProcessor`

Constructor Summary
`DefaultSelenium(CommandProcessor processor)` Uses an arbitrary CommandProcessor
`DefaultSelenium(java.lang.String serverHost, int serverPort, java.lang.String browserStartCommand, java.lang.String browserURL)` Uses a CommandBridgeClient, specifying a server host/port, a command to launch the browser, and a starting URL for the browser.

Method Summary
`void` | `addCustomRequestHeader(java.lang.String key, java.lang.String value)` Tells the Selenium server to add the specificed key and value as a custom outgoing request header.
`void` | `addLocationStrategy(java.lang.String strategyName, java.lang.String functionDefinition)` Defines a new function for Selenium to locate elements on the page.
`void` | `addScript(java.lang.String scriptContent, java.lang.String scriptTagId)` Loads script content into a new script tag in the Selenium document.
`void` | `addSelection(java.lang.String locator, java.lang.String optionLocator)` Add a selection to the set of selected options in a multi-select element using an option locator.
`void` | `allowNativeXpath(java.lang.String allow)` Specifies whether Selenium should use the native in-browser implementation of XPath (if any native version is available); if you pass "false" to this function, we will always use our pure-JavaScript xpath library.
`void` | `altKeyDown()` Press the alt key and hold it down until doAltUp() is called or a new page is loaded.
`void` | `altKeyUp()` Release the alt key.
`void` | `answerOnNextPrompt(java.lang.String answer)` Instructs Selenium to return the specified answer string in response to the next JavaScript prompt [window.prompt()].
`void` | `assignId(java.lang.String locator, java.lang.String identifier)` Temporarily sets the "id" attribute of the specified element, so you can locate it in the future using its ID rather than a slow/complicated XPath.
`void` | `attachFile(java.lang.String fieldLocator, java.lang.String fileLocator)` Sets a file input (upload) field to the file listed in fileLocator
`void` | `captureEntirePageScreenshot(java.lang.String filename, java.lang.String kwargs)` Saves the entire contents of the current window canvas to a PNG file.
`java.lang.String` | `captureEntirePageScreenshotToString(java.lang.String kwargs)` Downloads a screenshot of the browser current window canvas to a based 64 encoded PNG file.
`java.lang.String` | `captureNetworkTraffic(java.lang.String type)` Returns the network traffic seen by the browser, including headers, AJAX requests, status codes, and timings.
`void` | `captureScreenshot(java.lang.String filename)` Captures a PNG screenshot to the specified file.
`java.lang.String` | `captureScreenshotToString()` Capture a PNG screenshot.
`void` | `check(java.lang.String locator)` Check a toggle-button (checkbox/radio)
`void` | `chooseCancelOnNextConfirmation()` By default, Selenium's overridden window.confirm() function will return true, as if the user had manually clicked OK; after running this command, the next call to confirm() will return false, as if the user had clicked Cancel.
`void` | `chooseOkOnNextConfirmation()` Undo the effect of calling chooseCancelOnNextConfirmation.
`void` | `click(java.lang.String locator)` Clicks on a link, button, checkbox or radio button.
`void` | `clickAt(java.lang.String locator, java.lang.String coordString)` Clicks on a link, button, checkbox or radio button.
`void` | `close()` Simulates the user clicking the "close" button in the titlebar of a popup window or tab.
`void` | `contextMenu(java.lang.String locator)` Simulates opening the context menu for the specified element (as might happen if the user "right-clicked" on the element).
`void` | `contextMenuAt(java.lang.String locator, java.lang.String coordString)` Simulates opening the context menu for the specified element (as might happen if the user "right-clicked" on the element).
`void` | `controlKeyDown()` Press the control key and hold it down until doControlUp() is called or a new page is loaded.
`void` | `controlKeyUp()` Release the control key.
`void` | `createCookie(java.lang.String nameValuePair, java.lang.String optionsString)` Create a new cookie whose path and domain are same with those of current page under test, unless you specified a path for this cookie explicitly.
`void` | `deleteAllVisibleCookies()` Calls deleteCookie with recurse=true on all cookies visible to the current page.
`void` | `deleteCookie(java.lang.String name, java.lang.String optionsString)` Delete a named cookie with specified path and domain.
`void` | `deselectPopUp()` Selects the main window.
`void` | `doubleClick(java.lang.String locator)` Double clicks on a link, button, checkbox or radio button.
`void` | `doubleClickAt(java.lang.String locator, java.lang.String coordString)` Doubleclicks on a link, button, checkbox or radio button.
`void` | `dragAndDrop(java.lang.String locator, java.lang.String movementsString)` Drags an element a certain distance and then drops it
`void` | `dragAndDropToObject(java.lang.String locatorOfObjectToBeDragged, java.lang.String locatorOfDragDestinationObject)` Drags an element and drops it on another element
`void` | `dragdrop(java.lang.String locator, java.lang.String movementsString)` deprecated - use dragAndDrop instead
`void` | `fireEvent(java.lang.String locator, java.lang.String eventName)` Explicitly simulate an event, to trigger the corresponding "onevent" handler.
`void` | `focus(java.lang.String locator)` Move the focus to the specified element; for example, if the element is an input field, move the cursor to that field.
`java.lang.String` | `getAlert()` Retrieves the message of a JavaScript alert generated during the previous action, or fail if there were no alerts.
`java.lang.String[]` | `getAllButtons()` Returns the IDs of all buttons on the page.
`java.lang.String[]` | `getAllFields()` Returns the IDs of all input fields on the page.
`java.lang.String[]` | `getAllLinks()` Returns the IDs of all links on the page.
`java.lang.String[]` | `getAllWindowIds()` Returns the IDs of all windows that the browser knows about.
`java.lang.String[]` | `getAllWindowNames()` Returns the names of all windows that the browser knows about.
`java.lang.String[]` | `getAllWindowTitles()` Returns the titles of all windows that the browser knows about.
`java.lang.String` | `getAttribute(java.lang.String attributeLocator)` Gets the value of an element attribute.
`java.lang.String[]` | `getAttributeFromAllWindows(java.lang.String attributeName)` Returns every instance of some attribute from all known windows.
`java.lang.String` | `getBodyText()` Gets the entire text of the page.
`java.lang.String` | `getConfirmation()` Retrieves the message of a JavaScript confirmation dialog generated during the previous action.
`java.lang.String` | `getCookie()` Return all cookies of the current page under test.
`java.lang.String` | `getCookieByName(java.lang.String name)` Returns the value of the cookie with the specified name, or throws an error if the cookie is not present.
`java.lang.Number` | `getCursorPosition(java.lang.String locator)` Retrieves the text cursor position in the given input element or textarea; beware, this may not work perfectly on all browsers.
`java.lang.Number` | `getElementHeight(java.lang.String locator)` Retrieves the height of an element
`java.lang.Number` | `getElementIndex(java.lang.String locator)` Get the relative index of an element to its parent (starting from 0).
`java.lang.Number` | `getElementPositionLeft(java.lang.String locator)` Retrieves the horizontal position of an element
`java.lang.Number` | `getElementPositionTop(java.lang.String locator)` Retrieves the vertical position of an element
`java.lang.Number` | `getElementWidth(java.lang.String locator)` Retrieves the width of an element
`java.lang.String` | `getEval(java.lang.String script)` Gets the result of evaluating the specified JavaScript snippet.
`java.lang.String` | `getExpression(java.lang.String expression)` Returns the specified expression.
`java.lang.String` | `getHtmlSource()` Returns the entire HTML source between the opening and closing "html" tags.
`java.lang.String` | `getLocation()` Gets the absolute URL of the current page.
`java.lang.Number` | `getMouseSpeed()` Returns the number of pixels between "mousemove" events during dragAndDrop commands (default=10).
`java.lang.String` | `getPrompt()` Retrieves the message of a JavaScript question prompt dialog generated during the previous action.
`java.lang.String` | `getSelectedId(java.lang.String selectLocator)` Gets option element ID for selected option in the specified select element.
`java.lang.String[]` | `getSelectedIds(java.lang.String selectLocator)` Gets all option element IDs for selected options in the specified select or multi-select element.
`java.lang.String` | `getSelectedIndex(java.lang.String selectLocator)` Gets option index (option number, starting at 0) for selected option in the specified select element.
`java.lang.String[]` | `getSelectedIndexes(java.lang.String selectLocator)` Gets all option indexes (option number, starting at 0) for selected options in the specified select or multi-select element.
`java.lang.String` | `getSelectedLabel(java.lang.String selectLocator)` Gets option label (visible text) for selected option in the specified select element.
`java.lang.String[]` | `getSelectedLabels(java.lang.String selectLocator)` Gets all option labels (visible text) for selected options in the specified select or multi-select element.
`java.lang.String` | `getSelectedValue(java.lang.String selectLocator)` Gets option value (value attribute) for selected option in the specified select element.
`java.lang.String[]` | `getSelectedValues(java.lang.String selectLocator)` Gets all option values (value attributes) for selected options in the specified select or multi-select element.
`java.lang.String[]` | `getSelectOptions(java.lang.String selectLocator)` Gets all option labels in the specified select drop-down.
`java.lang.String` | `getSpeed()` Get execution speed (i.e., get the millisecond length of the delay following each selenium operation).
`java.lang.String` | `getTable(java.lang.String tableCellAddress)` Gets the text from a cell of a table.
`java.lang.String` | `getText(java.lang.String locator)` Gets the text of an element.
`java.lang.String` | `getTitle()` Gets the title of the current page.
`java.lang.String` | `getValue(java.lang.String locator)` Gets the (whitespace-trimmed) value of an input field (or anything else with a value parameter).
`boolean` | `getWhetherThisFrameMatchFrameExpression(java.lang.String currentFrameString, java.lang.String target)` Determine whether current/locator identify the frame containing this running code.
`boolean` | `getWhetherThisWindowMatchWindowExpression(java.lang.String currentWindowString, java.lang.String target)` Determine whether currentWindowString plus target identify the window containing this running code.
`java.lang.Number` | `getXpathCount(java.lang.String xpath)` Returns the number of nodes that match the specified xpath, eg.
`void` | `goBack()` Simulates the user clicking the "back" button on their browser.
`void` | `highlight(java.lang.String locator)` Briefly changes the backgroundColor of the specified element yellow.
`void` | `ignoreAttributesWithoutValue(java.lang.String ignore)` Specifies whether Selenium will ignore xpath attributes that have no value, i.e.
`boolean` | `isAlertPresent()` Has an alert occurred?
`boolean` | `isChecked(java.lang.String locator)` Gets whether a toggle-button (checkbox/radio) is checked.
`boolean` | `isConfirmationPresent()` Has confirm() been called?
`boolean` | `isCookiePresent(java.lang.String name)` Returns true if a cookie with the specified name is present, or false otherwise.
`boolean` | `isEditable(java.lang.String locator)` Determines whether the specified input element is editable, ie hasn't been disabled.
`boolean` | `isElementPresent(java.lang.String locator)` Verifies that the specified element is somewhere on the page.
`boolean` | `isOrdered(java.lang.String locator1, java.lang.String locator2)` Check if these two elements have same parent and are ordered siblings in the DOM.
`boolean` | `isPromptPresent()` Has a prompt occurred?
`boolean` | `isSomethingSelected(java.lang.String selectLocator)` Determines whether some option in a drop-down menu is selected.
`boolean` | `isTextPresent(java.lang.String pattern)` Verifies that the specified text pattern appears somewhere on the rendered page shown to the user.
`boolean` | `isVisible(java.lang.String locator)` Determines if the specified element is visible.
`void` | `keyDown(java.lang.String locator, java.lang.String keySequence)` Simulates a user pressing a key (without releasing it yet).
`void` | `keyDownNative(java.lang.String keycode)` Simulates a user pressing a key (without releasing it yet) by sending a native operating system keystroke.
`void` | `keyPress(java.lang.String locator, java.lang.String keySequence)` Simulates a user pressing and releasing a key.
`void` | `keyPressNative(java.lang.String keycode)` Simulates a user pressing and releasing a key by sending a native operating system keystroke.
`void` | `keyUp(java.lang.String locator, java.lang.String keySequence)` Simulates a user releasing a key.
`void` | `keyUpNative(java.lang.String keycode)` Simulates a user releasing a key by sending a native operating system keystroke.
`void` | `metaKeyDown()` Press the meta key and hold it down until doMetaUp() is called or a new page is loaded.
`void` | `metaKeyUp()` Release the meta key.
`void` | `mouseDown(java.lang.String locator)` Simulates a user pressing the left mouse button (without releasing it yet) on the specified element.
`void` | `mouseDownAt(java.lang.String locator, java.lang.String coordString)` Simulates a user pressing the left mouse button (without releasing it yet) at the specified location.
`void` | `mouseDownRight(java.lang.String locator)` Simulates a user pressing the right mouse button (without releasing it yet) on the specified element.
`void` | `mouseDownRightAt(java.lang.String locator, java.lang.String coordString)` Simulates a user pressing the right mouse button (without releasing it yet) at the specified location.
`void` | `mouseMove(java.lang.String locator)` Simulates a user pressing the mouse button (without releasing it yet) on the specified element.
`void` | `mouseMoveAt(java.lang.String locator, java.lang.String coordString)` Simulates a user pressing the mouse button (without releasing it yet) on the specified element.
`void` | `mouseOut(java.lang.String locator)` Simulates a user moving the mouse pointer away from the specified element.
`void` | `mouseOver(java.lang.String locator)` Simulates a user hovering a mouse over the specified element.
`void` | `mouseUp(java.lang.String locator)` Simulates the event that occurs when the user releases the mouse button (i.e., stops holding the button down) on the specified element.
`void` | `mouseUpAt(java.lang.String locator, java.lang.String coordString)` Simulates the event that occurs when the user releases the mouse button (i.e., stops holding the button down) at the specified location.
`void` | `mouseUpRight(java.lang.String locator)` Simulates the event that occurs when the user releases the right mouse button (i.e., stops holding the button down) on the specified element.
`void` | `mouseUpRightAt(java.lang.String locator, java.lang.String coordString)` Simulates the event that occurs when the user releases the right mouse button (i.e., stops holding the button down) at the specified location.
`void` | `open(java.lang.String url)` Opens an URL in the test frame.
`void` | `openWindow(java.lang.String url, java.lang.String windowID)` Opens a popup window (if a window with that ID isn't already open).
`void` | `refresh()` Simulates the user clicking the "Refresh" button on their browser.
`void` | `removeAllSelections(java.lang.String locator)` Unselects all of the selected options in a multi-select element.
`void` | `removeScript(java.lang.String scriptTagId)` Removes a script tag from the Selenium document identified by the given id.
`void` | `removeSelection(java.lang.String locator, java.lang.String optionLocator)` Remove a selection from the set of selected options in a multi-select element using an option locator.
`java.lang.String` | `retrieveLastRemoteControlLogs()` Retrieve the last messages logged on a specific remote control.
`void` | `rollup(java.lang.String rollupName, java.lang.String kwargs)` Executes a command rollup, which is a series of commands with a unique name, and optionally arguments that control the generation of the set of commands.
`void` | `runScript(java.lang.String script)` Creates a new "script" tag in the body of the current test window, and adds the specified text into the body of the command.
`void` | `select(java.lang.String selectLocator, java.lang.String optionLocator)` Select an option from a drop-down using an option locator.
`void` | `selectFrame(java.lang.String locator)` Selects a frame within the current window.
`void` | `selectPopUp(java.lang.String windowID)` Simplifies the process of selecting a popup window (and does not offer functionality beyond what `selectWindow()` already provides).
`void` | `selectWindow(java.lang.String windowID)` Selects a popup window using a window locator; once a popup window has been selected, all commands go to that window.
`void` | `setBrowserLogLevel(java.lang.String logLevel)` Sets the threshold for browser-side logging messages; log messages beneath this threshold will be discarded.
`void` | `setContext(java.lang.String context)` Writes a message to the status bar and adds a note to the browser-side log.
`void` | `setCursorPosition(java.lang.String locator, java.lang.String position)` Moves the text cursor to the specified position in the given input element or textarea.
`void` | `setExtensionJs(java.lang.String extensionJs)` Allows javascript to be specified for the test on a per-browser session basis.
`void` | `setMouseSpeed(java.lang.String pixels)` Configure the number of pixels between "mousemove" events during dragAndDrop commands (default=10).
`void` | `setSpeed(java.lang.String value)` Set execution speed (i.e., set the millisecond length of a delay which will follow each selenium operation).
`void` | `setTimeout(java.lang.String timeout)` Specifies the amount of time that Selenium will wait for actions to complete.
`void` | `shiftKeyDown()` Press the shift key and hold it down until doShiftUp() is called or a new page is loaded.
`void` | `shiftKeyUp()` Release the shift key.
`void` | `showContextualBanner()` Shows in the RemoteRunner a banner for the current test The banner is 'classname : methodname' where those two are derived from the caller The method name will be unCamelCased with the insertion of spaces at word boundaries
`void` | `showContextualBanner(java.lang.String className, java.lang.String methodName)` Shows in the RemoteRunner a banner for the current test The banner is 'classname : methodname' The method name will be unCamelCased with the insertion of spaces at word boundaries
`void` | `shutDownSeleniumServer()` Kills the running Selenium Server and all browser sessions.
`void` | `start()` Launches the browser with a new Selenium session
`void` | `start(java.lang.Object optionsObject)` Starts a new Selenium testing session with a configuration options object
`void` | `start(java.lang.String optionsString)` Starts a new Selenium testing session with a String, representing a configuration
`void` | `stop()` Ends the test session, killing the browser
`void` | `submit(java.lang.String formLocator)` Submit the specified form.
`void` | `type(java.lang.String locator, java.lang.String value)` Sets the value of an input field, as though you typed it in.
`void` | `typeKeys(java.lang.String locator, java.lang.String value)` Simulates keystroke events on the specified element, as though you typed the value key-by-key.
`void` | `uncheck(java.lang.String locator)` Uncheck a toggle-button (checkbox/radio)
`void` | `useXpathLibrary(java.lang.String libraryName)` Allows choice of one of the available libraries.
`void` | `waitForCondition(java.lang.String script, java.lang.String timeout)` Runs the specified JavaScript snippet repeatedly until it evaluates to "true".
`void` | `waitForFrameToLoad(java.lang.String frameAddress, java.lang.String timeout)` Waits for a new frame to load.
`void` | `waitForPageToLoad(java.lang.String timeout)` Waits for a new page to load.
`void` | `waitForPopUp(java.lang.String windowID, java.lang.String timeout)` Waits for a popup window to appear and load up.
`void` | `windowFocus()` Gives focus to the currently selected window
`void` | `windowMaximize()` Resize currently selected window to take up the entire screen

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### commandProcessor

    protected CommandProcessor commandProcessor

Constructor Detail

### DefaultSelenium

    public DefaultSelenium(java.lang.String serverHost,
                           int serverPort,
                           java.lang.String browserStartCommand,
                           java.lang.String browserURL)

  Uses a CommandBridgeClient, specifying a server host/port, a command to launch the browser, and a starting URL for the browser.

  browserStartCommand may be any one of the following:

  - `*firefox [absolute path]` - Automatically launch a new Firefox process using a custom Firefox profile. This profile will be automatically configured to use the Selenium Server as a proxy and to have all annoying prompts ("save your password?" "forms are insecure" "make Firefox your default browser?" disabled. You may optionally specify an absolute path to your firefox executable, or just say "*firefox". If no absolute path is specified, we'll look for firefox.exe in a default location (normally c:\program files\mozilla firefox\firefox.exe), which you can override by setting the Java system property `firefoxDefaultPath` to the correct path to Firefox.
  - `*iexplore [absolute path]` - Automatically launch a new Internet Explorer process using custom Windows registry settings. This process will be automatically configured to use the Selenium Server as a proxy and to have all annoying prompts ("save your password?" "forms are insecure" "make Firefox your default browser?" disabled. You may optionally specify an absolute path to your iexplore executable, or just say "*iexplore". If no absolute path is specified, we'll look for iexplore.exe in a default location (normally c:\program files\internet explorer\iexplore.exe), which you can override by setting the Java system property `iexploreDefaultPath` to the correct path to Internet Explorer.
  - `/path/to/my/browser [other arguments]` - You may also simply specify the absolute path to your browser executable, or use a relative path to your executable (which we'll try to find on your path). Warning: If you specify your own custom browser, it's up to you to configure it correctly. At a minimum, you'll need to configure your browser to use the Selenium Server as a proxy, and disable all browser-specific prompting.

  Parameters:
    `serverHost` - the host name on which the Selenium Server resides
    `serverPort` - the port on which the Selenium Server is listening
    `browserStartCommand` - the command string used to launch the browser, e.g. "*firefox", "*iexplore" or "c:\\program files\\internet explorer\\iexplore.exe"
    `browserURL` - the starting URL including just a domain name. We'll start the browser pointing at the Selenium resources on this URL, e.g. "http://www.google.com" would send the browser to "http://www.google.com/selenium-server/SeleneseRunner.html"

### DefaultSelenium

    public DefaultSelenium(CommandProcessor processor)

  Uses an arbitrary CommandProcessor

Method Detail

### setExtensionJs

    public void setExtensionJs(java.lang.String extensionJs)

  Allows javascript to be specified for the test on a per-browser session basis. The javascript will be in-play the next time a session is created; that is, typically the next time `start()` is invoked (and `getNewBrowserSession` is sent to the RC under the sheets).

  Specified by:
    `setExtensionJs` in interface `Selenium`
  Parameters:
    `extensionJs` - a string representing the extra extension javascript to include in the browser session. This is in addition to any specified via the -userExtensions switch when starting the RC.

### start

    public void start()

  Description copied from interface: `Selenium`
  Launches the browser with a new Selenium session

  Specified by:
    `start` in interface `Selenium`

### start

    public void start(java.lang.String optionsString)

  Description copied from interface: `Selenium`
  Starts a new Selenium testing session with a String, representing a configuration

  Specified by:
    `start` in interface `Selenium`

### start

    public void start(java.lang.Object optionsObject)

  Description copied from interface: `Selenium`
  Starts a new Selenium testing session with a configuration options object

  Specified by:
    `start` in interface `Selenium`

### stop

    public void stop()

  Description copied from interface: `Selenium`
  Ends the test session, killing the browser

  Specified by:
    `stop` in interface `Selenium`

### showContextualBanner

    public void showContextualBanner()

  Description copied from interface: `Selenium`
  Shows in the RemoteRunner a banner for the current test The banner is 'classname : methodname' where those two are derived from the caller The method name will be unCamelCased with the insertion of spaces at word boundaries

  Specified by:
    `showContextualBanner` in interface `Selenium`

### showContextualBanner

    public void showContextualBanner(java.lang.String className,
                                     java.lang.String methodName)

  Description copied from interface: `Selenium`
  Shows in the RemoteRunner a banner for the current test The banner is 'classname : methodname' The method name will be unCamelCased with the insertion of spaces at word boundaries

  Specified by:
    `showContextualBanner` in interface `Selenium`

### click

    public void click(java.lang.String locator)

  Description copied from interface: `Selenium`
  Clicks on a link, button, checkbox or radio button. If the click action causes a new page to load (like a link usually does), call waitForPageToLoad.

  Specified by:
    `click` in interface `Selenium`
  Parameters:
    `locator` - an element locator

### doubleClick

    public void doubleClick(java.lang.String locator)

  Description copied from interface: `Selenium`
  Double clicks on a link, button, checkbox or radio button. If the double click action causes a new page to load (like a link usually does), call waitForPageToLoad.

  Specified by:
    `doubleClick` in interface `Selenium`
  Parameters:
    `locator` - an element locator

### contextMenu

    public void contextMenu(java.lang.String locator)

  Description copied from interface: `Selenium`
  Simulates opening the context menu for the specified element (as might happen if the user "right-clicked" on the element).

  Specified by:
    `contextMenu` in interface `Selenium`
  Parameters:
    `locator` - an element locator

### clickAt

    public void clickAt(java.lang.String locator,
                        java.lang.String coordString)

  Description copied from interface: `Selenium`
  Clicks on a link, button, checkbox or radio button. If the click action causes a new page to load (like a link usually does), call waitForPageToLoad.

  Specified by:
    `clickAt` in interface `Selenium`
  Parameters:
    `locator` - an element locator
    `coordString` - specifies the x,y position (i.e. - 10,20) of the mouse event relative to the element returned by the locator.

### doubleClickAt

    public void doubleClickAt(java.lang.String locator,
                              java.lang.String coordString)

  Description copied from interface: `Selenium`
  Doubleclicks on a link, button, checkbox or radio button. If the action causes a new page to load (like a link usually does), call waitForPageToLoad.

  Specified by:
    `doubleClickAt` in interface `Selenium`
  Parameters:
    `locator` - an element locator
    `coordString` - specifies the x,y position (i.e. - 10,20) of the mouse event relative to the element returned by the locator.

### contextMenuAt

    public void contextMenuAt(java.lang.String locator,
                              java.lang.String coordString)

  Description copied from interface: `Selenium`
  Simulates opening the context menu for the specified element (as might happen if the user "right-clicked" on the element).

  Specified by:
    `contextMenuAt` in interface `Selenium`
  Parameters:
    `locator` - an element locator
    `coordString` - specifies the x,y position (i.e. - 10,20) of the mouse event relative to the element returned by the locator.

### fireEvent

    public void fireEvent(java.lang.String locator,
                          java.lang.String eventName)

  Description copied from interface: `Selenium`
  Explicitly simulate an event, to trigger the corresponding "onevent" handler.

  Specified by:
    `fireEvent` in interface `Selenium`
  Parameters:
    `locator` - an element locator
    `eventName` - the event name, e.g. "focus" or "blur"

### focus

    public void focus(java.lang.String locator)

  Description copied from interface: `Selenium`
  Move the focus to the specified element; for example, if the element is an input field, move the cursor to that field.

  Specified by:
    `focus` in interface `Selenium`
  Parameters:
    `locator` - an element locator

### keyPress

    public void keyPress(java.lang.String locator,
                         java.lang.String keySequence)

  Description copied from interface: `Selenium`
  Simulates a user pressing and releasing a key.

  Specified by:
    `keyPress` in interface `Selenium`
  Parameters:
    `locator` - an element locator
    `keySequence` - Either be a string("\" followed by the numeric keycode of the key to be pressed, normally the ASCII value of that key), or a single character. For example: "w", "\119".

### shiftKeyDown

    public void shiftKeyDown()

  Description copied from interface: `Selenium`
  Press the shift key and hold it down until doShiftUp() is called or a new page is loaded.

  Specified by:
    `shiftKeyDown` in interface `Selenium`

### shiftKeyUp

    public void shiftKeyUp()

  Description copied from interface: `Selenium`
  Release the shift key.

  Specified by:
    `shiftKeyUp` in interface `Selenium`

### metaKeyDown

    public void metaKeyDown()

  Description copied from interface: `Selenium`
  Press the meta key and hold it down until doMetaUp() is called or a new page is loaded.

  Specified by:
    `metaKeyDown` in interface `Selenium`

### metaKeyUp

    public void metaKeyUp()

  Description copied from interface: `Selenium`
  Release the meta key.

  Specified by:
    `metaKeyUp` in interface `Selenium`

### altKeyDown

    public void altKeyDown()

  Description copied from interface: `Selenium`
  Press the alt key and hold it down until doAltUp() is called or a new page is loaded.

  Specified by:
    `altKeyDown` in interface `Selenium`

### altKeyUp

    public void altKeyUp()

  Description copied from interface: `Selenium`
  Release the alt key.

  Specified by:
    `altKeyUp` in interface `Selenium`

### controlKeyDown

    public void controlKeyDown()

  Description copied from interface: `Selenium`
  Press the control key and hold it down until doControlUp() is called or a new page is loaded.

  Specified by:
    `controlKeyDown` in interface `Selenium`

### controlKeyUp

    public void controlKeyUp()

  Description copied from interface: `Selenium`
  Release the control key.

  Specified by:
    `controlKeyUp` in interface `Selenium`

### keyDown

    public void keyDown(java.lang.String locator,
                        java.lang.String keySequence)

  Description copied from interface: `Selenium`
  Simulates a user pressing a key (without releasing it yet).

  Specified by:
    `keyDown` in interface `Selenium`
  Parameters:
    `locator` - an element locator
    `keySequence` - Either be a string("\" followed by the numeric keycode of the key to be pressed, normally the ASCII value of that key), or a single character. For example: "w", "\119".

### keyUp

    public void keyUp(java.lang.String locator,
                      java.lang.String keySequence)

  Description copied from interface: `Selenium`
  Simulates a user releasing a key.

  Specified by:
    `keyUp` in interface `Selenium`
  Parameters:
    `locator` - an element locator
    `keySequence` - Either be a string("\" followed by the numeric keycode of the key to be pressed, normally the ASCII value of that key), or a single character. For example: "w", "\119".

### mouseOver

    public void mouseOver(java.lang.String locator)

  Description copied from interface: `Selenium`
  Simulates a user hovering a mouse over the specified element.

  Specified by:
    `mouseOver` in interface `Selenium`
  Parameters:
    `locator` - an element locator

### mouseOut

    public void mouseOut(java.lang.String locator)

  Description copied from interface: `Selenium`
  Simulates a user moving the mouse pointer away from the specified element.

  Specified by:
    `mouseOut` in interface `Selenium`
  Parameters:
    `locator` - an element locator

### mouseDown

    public void mouseDown(java.lang.String locator)

  Description copied from interface: `Selenium`
  Simulates a user pressing the left mouse button (without releasing it yet) on the specified element.

  Specified by:
    `mouseDown` in interface `Selenium`
  Parameters:
    `locator` - an element locator

### mouseDownRight

    public void mouseDownRight(java.lang.String locator)

  Description copied from interface: `Selenium`
  Simulates a user pressing the right mouse button (without releasing it yet) on the specified element.

  Specified by:
    `mouseDownRight` in interface `Selenium`
  Parameters:
    `locator` - an element locator

### mouseDownAt

    public void mouseDownAt(java.lang.String locator,
                            java.lang.String coordString)

  Description copied from interface: `Selenium`
  Simulates a user pressing the left mouse button (without releasing it yet) at the specified location.

  Specified by:
    `mouseDownAt` in interface `Selenium`
  Parameters:
    `locator` - an element locator
    `coordString` - specifies the x,y position (i.e. - 10,20) of the mouse event relative to the element returned by the locator.

### mouseDownRightAt

    public void mouseDownRightAt(java.lang.String locator,
                                 java.lang.String coordString)

  Description copied from interface: `Selenium`
  Simulates a user pressing the right mouse button (without releasing it yet) at the specified location.

  Specified by:
    `mouseDownRightAt` in interface `Selenium`
  Parameters:
    `locator` - an element locator
    `coordString` - specifies the x,y position (i.e. - 10,20) of the mouse event relative to the element returned by the locator.

### mouseUp

    public void mouseUp(java.lang.String locator)

  Description copied from interface: `Selenium`
  Simulates the event that occurs when the user releases the mouse button (i.e., stops holding the button down) on the specified element.

  Specified by:
    `mouseUp` in interface `Selenium`
  Parameters:
    `locator` - an element locator

### mouseUpRight

    public void mouseUpRight(java.lang.String locator)

  Description copied from interface: `Selenium`
  Simulates the event that occurs when the user releases the right mouse button (i.e., stops holding the button down) on the specified element.

  Specified by:
    `mouseUpRight` in interface `Selenium`
  Parameters:
    `locator` - an element locator

### mouseUpAt

    public void mouseUpAt(java.lang.String locator,
                          java.lang.String coordString)

  Description copied from interface: `Selenium`
  Simulates the event that occurs when the user releases the mouse button (i.e., stops holding the button down) at the specified location.

  Specified by:
    `mouseUpAt` in interface `Selenium`
  Parameters:
    `locator` - an element locator
    `coordString` - specifies the x,y position (i.e. - 10,20) of the mouse event relative to the element returned by the locator.

### mouseUpRightAt

    public void mouseUpRightAt(java.lang.String locator,
                               java.lang.String coordString)

  Description copied from interface: `Selenium`
  Simulates the event that occurs when the user releases the right mouse button (i.e., stops holding the button down) at the specified location.

  Specified by:
    `mouseUpRightAt` in interface `Selenium`
  Parameters:
    `locator` - an element locator
    `coordString` - specifies the x,y position (i.e. - 10,20) of the mouse event relative to the element returned by the locator.

### mouseMove

    public void mouseMove(java.lang.String locator)

  Description copied from interface: `Selenium`
  Simulates a user pressing the mouse button (without releasing it yet) on the specified element.

  Specified by:
    `mouseMove` in interface `Selenium`
  Parameters:
    `locator` - an element locator

### mouseMoveAt

    public void mouseMoveAt(java.lang.String locator,
                            java.lang.String coordString)

  Description copied from interface: `Selenium`
  Simulates a user pressing the mouse button (without releasing it yet) on the specified element.

  Specified by:
    `mouseMoveAt` in interface `Selenium`
  Parameters:
    `locator` - an element locator
    `coordString` - specifies the x,y position (i.e. - 10,20) of the mouse event relative to the element returned by the locator.

### type

    public void type(java.lang.String locator,
                     java.lang.String value)

  Description copied from interface: `Selenium`
  Sets the value of an input field, as though you typed it in.

  Can also be used to set the value of combo boxes, check boxes, etc. In these cases, value should be the value of the option selected, not the visible text.

  Specified by:
    `type` in interface `Selenium`
  Parameters:
    `locator` - an element locator
    `value` - the value to type

### typeKeys

    public void typeKeys(java.lang.String locator,
                         java.lang.String value)

  Description copied from interface: `Selenium`
  Simulates keystroke events on the specified element, as though you typed the value key-by-key.

  This is a convenience method for calling keyDown, keyUp, keyPress for every character in the specified string; this is useful for dynamic UI widgets (like auto-completing combo boxes) that require explicit key events.

  Unlike the simple "type" command, which forces the specified value into the page directly, this command may or may not have any visible effect, even in cases where typing keys would normally have a visible effect. For example, if you use "typeKeys" on a form element, you may or may not see the results of what you typed in the field.

  In some cases, you may need to use the simple "type" command to set the value of the field and then the "typeKeys" command to send the keystroke events corresponding to what you just typed.

  Specified by:
    `typeKeys` in interface `Selenium`
  Parameters:
    `locator` - an element locator
    `value` - the value to type

### setSpeed

    public void setSpeed(java.lang.String value)

  Description copied from interface: `Selenium`
  Set execution speed (i.e., set the millisecond length of a delay which will follow each selenium operation). By default, there is no such delay, i.e., the delay is 0 milliseconds.

  Specified by:
    `setSpeed` in interface `Selenium`
  Parameters:
    `value` - the number of milliseconds to pause after operation

### getSpeed

    public java.lang.String getSpeed()

  Description copied from interface: `Selenium`
  Get execution speed (i.e., get the millisecond length of the delay following each selenium operation). By default, there is no such delay, i.e., the delay is 0 milliseconds. See also setSpeed.

  Specified by:
    `getSpeed` in interface `Selenium`
  Returns:
    the execution speed in milliseconds.

### check

    public void check(java.lang.String locator)

  Description copied from interface: `Selenium`
  Check a toggle-button (checkbox/radio)

  Specified by:
    `check` in interface `Selenium`
  Parameters:
    `locator` - an element locator

### uncheck

    public void uncheck(java.lang.String locator)

  Description copied from interface: `Selenium`
  Uncheck a toggle-button (checkbox/radio)

  Specified by:
    `uncheck` in interface `Selenium`
  Parameters:
    `locator` - an element locator

### select

    public void select(java.lang.String selectLocator,
                       java.lang.String optionLocator)

  Description copied from interface: `Selenium`
  Select an option from a drop-down using an option locator.

  Option locators provide different ways of specifying options of an HTML Select element (e.g. for selecting a specific option, or for asserting that the selected option satisfies a specification). There are several forms of Select Option Locator.

  - label=labelPattern: matches options based on their labels, i.e. the visible text. (This is the default.)
    - label=regexp:^[Oo]ther
  - value=valuePattern: matches options based on their values.
    - value=other
  - id=id: matches options based on their ids.
    - id=option1
  - index=index: matches an option based on its index (offset from zero).
    - index=2

  If no option locator prefix is provided, the default behaviour is to match on label.

  Specified by:
    `select` in interface `Selenium`
  Parameters:
    `selectLocator` - an element locator identifying a drop-down menu
    `optionLocator` - an option locator (a label by default)

### addSelection

    public void addSelection(java.lang.String locator,
                             java.lang.String optionLocator)

  Description copied from interface: `Selenium`
  Add a selection to the set of selected options in a multi-select element using an option locator.

  Specified by:
    `addSelection` in interface `Selenium`
  Parameters:
    `locator` - an element locator identifying a multi-select box
    `optionLocator` - an option locator (a label by default)
  See Also:
    `for details of option locators`

### removeSelection

    public void removeSelection(java.lang.String locator,
                                java.lang.String optionLocator)

  Description copied from interface: `Selenium`
  Remove a selection from the set of selected options in a multi-select element using an option locator.

  Specified by:
    `removeSelection` in interface `Selenium`
  Parameters:
    `locator` - an element locator identifying a multi-select box
    `optionLocator` - an option locator (a label by default)
  See Also:
    `for details of option locators`

### removeAllSelections

    public void removeAllSelections(java.lang.String locator)

  Description copied from interface: `Selenium`
  Unselects all of the selected options in a multi-select element.

  Specified by:
    `removeAllSelections` in interface `Selenium`
  Parameters:
    `locator` - an element locator identifying a multi-select box

### submit

    public void submit(java.lang.String formLocator)

  Description copied from interface: `Selenium`
  Submit the specified form. This is particularly useful for forms without submit buttons, e.g. single-input "Search" forms.

  Specified by:
    `submit` in interface `Selenium`
  Parameters:
    `formLocator` - an element locator for the form you want to submit

### open

    public void open(java.lang.String url)

  Description copied from interface: `Selenium`
  Opens an URL in the test frame. This accepts both relative and absolute URLs. The "open" command waits for the page to load before proceeding, ie. the "AndWait" suffix is implicit. Note: The URL must be on the same domain as the runner HTML due to security restrictions in the browser (Same Origin Policy). If you need to open an URL on another domain, use the Selenium Server to start a new browser session on that domain.

  Specified by:
    `open` in interface `Selenium`
  Parameters:
    `url` - the URL to open; may be relative or absolute

### openWindow

    public void openWindow(java.lang.String url,
                           java.lang.String windowID)

  Description copied from interface: `Selenium`
  Opens a popup window (if a window with that ID isn't already open). After opening the window, you'll need to select it using the selectWindow command.

  This command can also be a useful workaround for bug SEL-339. In some cases, Selenium will be unable to intercept a call to window.open (if the call occurs during or before the "onLoad" event, for example). In those cases, you can force Selenium to notice the open window's name by using the Selenium openWindow command, using an empty (blank) url, like this: openWindow("", "myFunnyWindow").

  Specified by:
    `openWindow` in interface `Selenium`
  Parameters:
    `url` - the URL to open, which can be blank
    `windowID` - the JavaScript window ID of the window to select

### selectWindow

    public void selectWindow(java.lang.String windowID)

  Description copied from interface: `Selenium`
  Selects a popup window using a window locator; once a popup window has been selected, all commands go to that window. To select the main window again, use null as the target.

  Window locators provide different ways of specifying the window object: by title, by internal JavaScript "name," or by JavaScript variable.

  - title=My Special Window: Finds the window using the text that appears in the title bar. Be careful; two windows can share the same title. If that happens, this locator will just pick one.
  - name=myWindow: Finds the window using its internal JavaScript "name" property. This is the second parameter "windowName" passed to the JavaScript method window.open(url, windowName, windowFeatures, replaceFlag) (which Selenium intercepts).
  - var=variableName: Some pop-up windows are unnamed (anonymous), but are associated with a JavaScript variable name in the current application window, e.g. "window.foo = window.open(url);". In those cases, you can open the window using "var=foo".

  If no window locator prefix is provided, we'll try to guess what you mean like this:

  1.) if windowID is null, (or the string "null") then it is assumed the user is referring to the original window instantiated by the browser).

  2.) if the value of the "windowID" parameter is a JavaScript variable name in the current application window, then it is assumed that this variable contains the return value from a call to the JavaScript window.open() method.

  3.) Otherwise, selenium looks in a hash it maintains that maps string names to window "names".

  4.) If that fails, we'll try looping over all of the known windows to try to find the appropriate "title". Since "title" is not necessarily unique, this may have unexpected behavior.

  If you're having trouble figuring out the name of a window that you want to manipulate, look at the Selenium log messages which identify the names of windows created via window.open (and therefore intercepted by Selenium). You will see messages like the following for each window as it is opened:

  `debug: window.open call intercepted; window ID (which you can use with selectWindow()) is "myNewWindow"`

  In some cases, Selenium will be unable to intercept a call to window.open (if the call occurs during or before the "onLoad" event, for example). (This is bug SEL-339.) In those cases, you can force Selenium to notice the open window's name by using the Selenium openWindow command, using an empty (blank) url, like this: openWindow("", "myFunnyWindow").

  Specified by:
    `selectWindow` in interface `Selenium`
  Parameters:
    `windowID` - the JavaScript window ID of the window to select

### selectPopUp

    public void selectPopUp(java.lang.String windowID)

  Description copied from interface: `Selenium`
  Simplifies the process of selecting a popup window (and does not offer functionality beyond what `selectWindow()` already provides).
  - If `windowID` is either not specified, or specified as "null", the first non-top window is selected. The top window is the one that would be selected by `selectWindow()` without providing a `windowID` . This should not be used when more than one popup window is in play.
  - Otherwise, the window will be looked up considering `windowID` as the following in order: 1) the "name" of the window, as specified to `window.open()`; 2) a javascript variable which is a reference to a window; and 3) the title of the window. This is the same ordered lookup performed by `selectWindow` .

  Specified by:
    `selectPopUp` in interface `Selenium`
  Parameters:
    `windowID` - an identifier for the popup window, which can take on a number of different meanings

### deselectPopUp

    public void deselectPopUp()

  Description copied from interface: `Selenium`
  Selects the main window. Functionally equivalent to using `selectWindow()` and specifying no value for `windowID`.

  Specified by:
    `deselectPopUp` in interface `Selenium`

### selectFrame

    public void selectFrame(java.lang.String locator)

  Description copied from interface: `Selenium`
  Selects a frame within the current window. (You may invoke this command multiple times to select nested frames.) To select the parent frame, use "relative=parent" as a locator; to select the top frame, use "relative=top". You can also select a frame by its 0-based index number; select the first frame with "index=0", or the third frame with "index=2".

  You may also use a DOM expression to identify the frame you want directly, like this: `dom=frames["main"].frames["subframe"]`

  Specified by:
    `selectFrame` in interface `Selenium`
  Parameters:
    `locator` - an element locator identifying a frame or iframe

### getWhetherThisFrameMatchFrameExpression

    public boolean getWhetherThisFrameMatchFrameExpression(java.lang.String currentFrameString,
                                                           java.lang.String target)

  Description copied from interface: `Selenium`
  Determine whether current/locator identify the frame containing this running code.

  This is useful in proxy injection mode, where this code runs in every browser frame and window, and sometimes the selenium server needs to identify the "current" frame. In this case, when the test calls selectFrame, this routine is called for each frame to figure out which one has been selected. The selected frame will return true, while all others will return false.

  Specified by:
    `getWhetherThisFrameMatchFrameExpression` in interface `Selenium`
  Parameters:
    `currentFrameString` - starting frame
    `target` - new frame (which might be relative to the current one)
  Returns:
    true if the new frame is this code's window

### getWhetherThisWindowMatchWindowExpression

    public boolean getWhetherThisWindowMatchWindowExpression(java.lang.String currentWindowString,
                                                             java.lang.String target)

  Description copied from interface: `Selenium`
  Determine whether currentWindowString plus target identify the window containing this running code.

  This is useful in proxy injection mode, where this code runs in every browser frame and window, and sometimes the selenium server needs to identify the "current" window. In this case, when the test calls selectWindow, this routine is called for each window to figure out which one has been selected. The selected window will return true, while all others will return false.

  Specified by:
    `getWhetherThisWindowMatchWindowExpression` in interface `Selenium`
  Parameters:
    `currentWindowString` - starting window
    `target` - new window (which might be relative to the current one, e.g., "_parent")
  Returns:
    true if the new window is this code's window

### waitForPopUp

    public void waitForPopUp(java.lang.String windowID,
                             java.lang.String timeout)

  Description copied from interface: `Selenium`
  Waits for a popup window to appear and load up.

  Specified by:
    `waitForPopUp` in interface `Selenium`
  Parameters:
    `windowID` - the JavaScript window "name" of the window that will appear (not the text of the title bar) If unspecified, or specified as "null", this command will wait for the first non-top window to appear (don't rely on this if you are working with multiple popups simultaneously).
    `timeout` - a timeout in milliseconds, after which the action will return with an error. If this value is not specified, the default Selenium timeout will be used. See the setTimeout() command.

### chooseCancelOnNextConfirmation

    public void chooseCancelOnNextConfirmation()

  Description copied from interface: `Selenium`

  By default, Selenium's overridden window.confirm() function will return true, as if the user had manually clicked OK; after running this command, the next call to confirm() will return false, as if the user had clicked Cancel. Selenium will then resume using the default behavior for future confirmations, automatically returning true (OK) unless/until you explicitly call this command for each confirmation.

  Take note - every time a confirmation comes up, you must consume it with a corresponding getConfirmation, or else the next selenium operation will fail.

  Specified by:
    `chooseCancelOnNextConfirmation` in interface `Selenium`

### chooseOkOnNextConfirmation

    public void chooseOkOnNextConfirmation()

  Description copied from interface: `Selenium`

  Undo the effect of calling chooseCancelOnNextConfirmation. Note that Selenium's overridden window.confirm() function will normally automatically return true, as if the user had manually clicked OK, so you shouldn't need to use this command unless for some reason you need to change your mind prior to the next confirmation. After any confirmation, Selenium will resume using the default behavior for future confirmations, automatically returning true (OK) unless/until you explicitly call chooseCancelOnNextConfirmation for each confirmation.

  Take note - every time a confirmation comes up, you must consume it with a corresponding getConfirmation, or else the next selenium operation will fail.

  Specified by:
    `chooseOkOnNextConfirmation` in interface `Selenium`

### answerOnNextPrompt

    public void answerOnNextPrompt(java.lang.String answer)

  Description copied from interface: `Selenium`
  Instructs Selenium to return the specified answer string in response to the next JavaScript prompt [window.prompt()].

  Specified by:
    `answerOnNextPrompt` in interface `Selenium`
  Parameters:
    `answer` - the answer to give in response to the prompt pop-up

### goBack

    public void goBack()

  Description copied from interface: `Selenium`
  Simulates the user clicking the "back" button on their browser.

  Specified by:
    `goBack` in interface `Selenium`

### refresh

    public void refresh()

  Description copied from interface: `Selenium`
  Simulates the user clicking the "Refresh" button on their browser.

  Specified by:
    `refresh` in interface `Selenium`

### close

    public void close()

  Description copied from interface: `Selenium`
  Simulates the user clicking the "close" button in the titlebar of a popup window or tab.

  Specified by:
    `close` in interface `Selenium`

### isAlertPresent

    public boolean isAlertPresent()

  Description copied from interface: `Selenium`
  Has an alert occurred?

  This function never throws an exception

  Specified by:
    `isAlertPresent` in interface `Selenium`
  Returns:
    true if there is an alert

### isPromptPresent

    public boolean isPromptPresent()

  Description copied from interface: `Selenium`
  Has a prompt occurred?

  This function never throws an exception

  Specified by:
    `isPromptPresent` in interface `Selenium`
  Returns:
    true if there is a pending prompt

### isConfirmationPresent

    public boolean isConfirmationPresent()

  Description copied from interface: `Selenium`
  Has confirm() been called?

  This function never throws an exception

  Specified by:
    `isConfirmationPresent` in interface `Selenium`
  Returns:
    true if there is a pending confirmation

### getAlert

    public java.lang.String getAlert()

  Description copied from interface: `Selenium`
  Retrieves the message of a JavaScript alert generated during the previous action, or fail if there were no alerts.

  Getting an alert has the same effect as manually clicking OK. If an alert is generated but you do not consume it with getAlert, the next Selenium action will fail.

  Under Selenium, JavaScript alerts will NOT pop up a visible alert dialog.

  Selenium does NOT support JavaScript alerts that are generated in a page's onload() event handler. In this case a visible dialog WILL be generated and Selenium will hang until someone manually clicks OK.

  Specified by:
    `getAlert` in interface `Selenium`
  Returns:
    The message of the most recent JavaScript alert

### getConfirmation

    public java.lang.String getConfirmation()

  Description copied from interface: `Selenium`
  Retrieves the message of a JavaScript confirmation dialog generated during the previous action.

  By default, the confirm function will return true, having the same effect as manually clicking OK. This can be changed by prior execution of the chooseCancelOnNextConfirmation command.

  If an confirmation is generated but you do not consume it with getConfirmation, the next Selenium action will fail.

  NOTE: under Selenium, JavaScript confirmations will NOT pop up a visible dialog.

  NOTE: Selenium does NOT support JavaScript confirmations that are generated in a page's onload() event handler. In this case a visible dialog WILL be generated and Selenium will hang until you manually click OK.

  Specified by:
    `getConfirmation` in interface `Selenium`
  Returns:
    the message of the most recent JavaScript confirmation dialog

### getPrompt

    public java.lang.String getPrompt()

  Description copied from interface: `Selenium`
  Retrieves the message of a JavaScript question prompt dialog generated during the previous action.

  Successful handling of the prompt requires prior execution of the answerOnNextPrompt command. If a prompt is generated but you do not get/verify it, the next Selenium action will fail.

  NOTE: under Selenium, JavaScript prompts will NOT pop up a visible dialog.

  NOTE: Selenium does NOT support JavaScript prompts that are generated in a page's onload() event handler. In this case a visible dialog WILL be generated and Selenium will hang until someone manually clicks OK.

  Specified by:
    `getPrompt` in interface `Selenium`
  Returns:
    the message of the most recent JavaScript question prompt

### getLocation

    public java.lang.String getLocation()

  Description copied from interface: `Selenium`
  Gets the absolute URL of the current page.

  Specified by:
    `getLocation` in interface `Selenium`
  Returns:
    the absolute URL of the current page

### getTitle

    public java.lang.String getTitle()

  Description copied from interface: `Selenium`
  Gets the title of the current page.

  Specified by:
    `getTitle` in interface `Selenium`
  Returns:
    the title of the current page

### getBodyText

    public java.lang.String getBodyText()

  Description copied from interface: `Selenium`
  Gets the entire text of the page.

  Specified by:
    `getBodyText` in interface `Selenium`
  Returns:
    the entire text of the page

### getValue

    public java.lang.String getValue(java.lang.String locator)

  Description copied from interface: `Selenium`
  Gets the (whitespace-trimmed) value of an input field (or anything else with a value parameter). For checkbox/radio elements, the value will be "on" or "off" depending on whether the element is checked or not.

  Specified by:
    `getValue` in interface `Selenium`
  Parameters:
    `locator` - an element locator
  Returns:
    the element value, or "on/off" for checkbox/radio elements

### getText

    public java.lang.String getText(java.lang.String locator)

  Description copied from interface: `Selenium`
  Gets the text of an element. This works for any element that contains text. This command uses either the textContent (Mozilla-like browsers) or the innerText (IE-like browsers) of the element, which is the rendered text shown to the user.

  Specified by:
    `getText` in interface `Selenium`
  Parameters:
    `locator` - an element locator
  Returns:
    the text of the element

### highlight

    public void highlight(java.lang.String locator)

  Description copied from interface: `Selenium`
  Briefly changes the backgroundColor of the specified element yellow. Useful for debugging.

  Specified by:
    `highlight` in interface `Selenium`
  Parameters:
    `locator` - an element locator

### getEval

    public java.lang.String getEval(java.lang.String script)

  Description copied from interface: `Selenium`
  Gets the result of evaluating the specified JavaScript snippet. The snippet may have multiple lines, but only the result of the last line will be returned.

  Note that, by default, the snippet will run in the context of the "selenium" object itself, so `this` will refer to the Selenium object. Use `window` to refer to the window of your application, e.g. `window.document.getElementById('foo')`

  If you need to use a locator to refer to a single element in your application page, you can use `this.browserbot.findElement("id=foo")` where "id=foo" is your locator.

  Specified by:
    `getEval` in interface `Selenium`
  Parameters:
    `script` - the JavaScript snippet to run
  Returns:
    the results of evaluating the snippet

### isChecked

    public boolean isChecked(java.lang.String locator)

  Description copied from interface: `Selenium`
  Gets whether a toggle-button (checkbox/radio) is checked. Fails if the specified element doesn't exist or isn't a toggle-button.

  Specified by:
    `isChecked` in interface `Selenium`
  Parameters:
    `locator` - an element locator pointing to a checkbox or radio button
  Returns:
    true if the checkbox is checked, false otherwise

### getTable

    public java.lang.String getTable(java.lang.String tableCellAddress)

  Description copied from interface: `Selenium`
  Gets the text from a cell of a table. The cellAddress syntax tableLocator.row.column, where row and column start at 0.

  Specified by:
    `getTable` in interface `Selenium`
  Parameters:
    `tableCellAddress` - a cell address, e.g. "foo.1.4"
  Returns:
    the text from the specified cell

### getSelectedLabels

    public java.lang.String[] getSelectedLabels(java.lang.String selectLocator)

  Description copied from interface: `Selenium`
  Gets all option labels (visible text) for selected options in the specified select or multi-select element.

  Specified by:
    `getSelectedLabels` in interface `Selenium`
  Parameters:
    `selectLocator` - an element locator identifying a drop-down menu
  Returns:
    an array of all selected option labels in the specified select drop-down

### getSelectedLabel

    public java.lang.String getSelectedLabel(java.lang.String selectLocator)

  Description copied from interface: `Selenium`
  Gets option label (visible text) for selected option in the specified select element.

  Specified by:
    `getSelectedLabel` in interface `Selenium`
  Parameters:
    `selectLocator` - an element locator identifying a drop-down menu
  Returns:
    the selected option label in the specified select drop-down

### getSelectedValues

    public java.lang.String[] getSelectedValues(java.lang.String selectLocator)

  Description copied from interface: `Selenium`
  Gets all option values (value attributes) for selected options in the specified select or multi-select element.

  Specified by:
    `getSelectedValues` in interface `Selenium`
  Parameters:
    `selectLocator` - an element locator identifying a drop-down menu
  Returns:
    an array of all selected option values in the specified select drop-down

### getSelectedValue

    public java.lang.String getSelectedValue(java.lang.String selectLocator)

  Description copied from interface: `Selenium`
  Gets option value (value attribute) for selected option in the specified select element.

  Specified by:
    `getSelectedValue` in interface `Selenium`
  Parameters:
    `selectLocator` - an element locator identifying a drop-down menu
  Returns:
    the selected option value in the specified select drop-down

### getSelectedIndexes

    public java.lang.String[] getSelectedIndexes(java.lang.String selectLocator)

  Description copied from interface: `Selenium`
  Gets all option indexes (option number, starting at 0) for selected options in the specified select or multi-select element.

  Specified by:
    `getSelectedIndexes` in interface `Selenium`
  Parameters:
    `selectLocator` - an element locator identifying a drop-down menu
  Returns:
    an array of all selected option indexes in the specified select drop-down

### getSelectedIndex

    public java.lang.String getSelectedIndex(java.lang.String selectLocator)

  Description copied from interface: `Selenium`
  Gets option index (option number, starting at 0) for selected option in the specified select element.

  Specified by:
    `getSelectedIndex` in interface `Selenium`
  Parameters:
    `selectLocator` - an element locator identifying a drop-down menu
  Returns:
    the selected option index in the specified select drop-down

### getSelectedIds

    public java.lang.String[] getSelectedIds(java.lang.String selectLocator)

  Description copied from interface: `Selenium`
  Gets all option element IDs for selected options in the specified select or multi-select element.

  Specified by:
    `getSelectedIds` in interface `Selenium`
  Parameters:
    `selectLocator` - an element locator identifying a drop-down menu
  Returns:
    an array of all selected option IDs in the specified select drop-down

### getSelectedId

    public java.lang.String getSelectedId(java.lang.String selectLocator)

  Description copied from interface: `Selenium`
  Gets option element ID for selected option in the specified select element.

  Specified by:
    `getSelectedId` in interface `Selenium`
  Parameters:
    `selectLocator` - an element locator identifying a drop-down menu
  Returns:
    the selected option ID in the specified select drop-down

### isSomethingSelected

    public boolean isSomethingSelected(java.lang.String selectLocator)

  Description copied from interface: `Selenium`
  Determines whether some option in a drop-down menu is selected.

  Specified by:
    `isSomethingSelected` in interface `Selenium`
  Parameters:
    `selectLocator` - an element locator identifying a drop-down menu
  Returns:
    true if some option has been selected, false otherwise

### getSelectOptions

    public java.lang.String[] getSelectOptions(java.lang.String selectLocator)

  Description copied from interface: `Selenium`
  Gets all option labels in the specified select drop-down.

  Specified by:
    `getSelectOptions` in interface `Selenium`
  Parameters:
    `selectLocator` - an element locator identifying a drop-down menu
  Returns:
    an array of all option labels in the specified select drop-down

### getAttribute

    public java.lang.String getAttribute(java.lang.String attributeLocator)

  Description copied from interface: `Selenium`
  Gets the value of an element attribute. The value of the attribute may differ across browsers (this is the case for the "style" attribute, for example).

  Specified by:
    `getAttribute` in interface `Selenium`
  Parameters:
    `attributeLocator` - an element locator followed by an @ sign and then the name of the attribute, e.g. "foo@bar"
  Returns:
    the value of the specified attribute

### isTextPresent

    public boolean isTextPresent(java.lang.String pattern)

  Description copied from interface: `Selenium`
  Verifies that the specified text pattern appears somewhere on the rendered page shown to the user.

  Specified by:
    `isTextPresent` in interface `Selenium`
  Parameters:
    `pattern` - a pattern to match with the text of the page
  Returns:
    true if the pattern matches the text, false otherwise

### isElementPresent

    public boolean isElementPresent(java.lang.String locator)

  Description copied from interface: `Selenium`
  Verifies that the specified element is somewhere on the page.

  Specified by:
    `isElementPresent` in interface `Selenium`
  Parameters:
    `locator` - an element locator
  Returns:
    true if the element is present, false otherwise

### isVisible

    public boolean isVisible(java.lang.String locator)

  Description copied from interface: `Selenium`
  Determines if the specified element is visible. An element can be rendered invisible by setting the CSS "visibility" property to "hidden", or the "display" property to "none", either for the element itself or one if its ancestors. This method will fail if the element is not present.

  Specified by:
    `isVisible` in interface `Selenium`
  Parameters:
    `locator` - an element locator
  Returns:
    true if the specified element is visible, false otherwise

### isEditable

    public boolean isEditable(java.lang.String locator)

  Description copied from interface: `Selenium`
  Determines whether the specified input element is editable, ie hasn't been disabled. This method will fail if the specified element isn't an input element.

  Specified by:
    `isEditable` in interface `Selenium`
  Parameters:
    `locator` - an element locator
  Returns:
    true if the input element is editable, false otherwise

### getAllButtons

    public java.lang.String[] getAllButtons()

  Description copied from interface: `Selenium`
  Returns the IDs of all buttons on the page.

  If a given button has no ID, it will appear as "" in this array.

  Specified by:
    `getAllButtons` in interface `Selenium`
  Returns:
    the IDs of all buttons on the page

### getAllLinks

    public java.lang.String[] getAllLinks()

  Description copied from interface: `Selenium`
  Returns the IDs of all links on the page.

  If a given link has no ID, it will appear as "" in this array.

  Specified by:
    `getAllLinks` in interface `Selenium`
  Returns:
    the IDs of all links on the page

### getAllFields

    public java.lang.String[] getAllFields()

  Description copied from interface: `Selenium`
  Returns the IDs of all input fields on the page.

  If a given field has no ID, it will appear as "" in this array.

  Specified by:
    `getAllFields` in interface `Selenium`
  Returns:
    the IDs of all field on the page

### getAttributeFromAllWindows

    public java.lang.String[] getAttributeFromAllWindows(java.lang.String attributeName)

  Description copied from interface: `Selenium`
  Returns every instance of some attribute from all known windows.

  Specified by:
    `getAttributeFromAllWindows` in interface `Selenium`
  Parameters:
    `attributeName` - name of an attribute on the windows
  Returns:
    the set of values of this attribute from all known windows.

### dragdrop

    public void dragdrop(java.lang.String locator,
                         java.lang.String movementsString)

  Description copied from interface: `Selenium`
  deprecated - use dragAndDrop instead

  Specified by:
    `dragdrop` in interface `Selenium`
  Parameters:
    `locator` - an element locator
    `movementsString` - offset in pixels from the current location to which the element should be moved, e.g., "+70,-300"

### setMouseSpeed

    public void setMouseSpeed(java.lang.String pixels)

  Description copied from interface: `Selenium`
  Configure the number of pixels between "mousemove" events during dragAndDrop commands (default=10).

  Setting this value to 0 means that we'll send a "mousemove" event to every single pixel in between the start location and the end location; that can be very slow, and may cause some browsers to force the JavaScript to timeout.

  If the mouse speed is greater than the distance between the two dragged objects, we'll just send one "mousemove" at the start location and then one final one at the end location.

  Specified by:
    `setMouseSpeed` in interface `Selenium`
  Parameters:
    `pixels` - the number of pixels between "mousemove" events

### getMouseSpeed

    public java.lang.Number getMouseSpeed()

  Description copied from interface: `Selenium`
  Returns the number of pixels between "mousemove" events during dragAndDrop commands (default=10).

  Specified by:
    `getMouseSpeed` in interface `Selenium`
  Returns:
    the number of pixels between "mousemove" events during dragAndDrop commands (default=10)

### dragAndDrop

    public void dragAndDrop(java.lang.String locator,
                            java.lang.String movementsString)

  Description copied from interface: `Selenium`
  Drags an element a certain distance and then drops it

  Specified by:
    `dragAndDrop` in interface `Selenium`
  Parameters:
    `locator` - an element locator
    `movementsString` - offset in pixels from the current location to which the element should be moved, e.g., "+70,-300"

### dragAndDropToObject

    public void dragAndDropToObject(java.lang.String locatorOfObjectToBeDragged,
                                    java.lang.String locatorOfDragDestinationObject)

  Description copied from interface: `Selenium`
  Drags an element and drops it on another element

  Specified by:
    `dragAndDropToObject` in interface `Selenium`
  Parameters:
    `locatorOfObjectToBeDragged` - an element to be dragged
    `locatorOfDragDestinationObject` - an element whose location (i.e., whose center-most pixel) will be the point where locatorOfObjectToBeDragged is dropped

### windowFocus

    public void windowFocus()

  Description copied from interface: `Selenium`
  Gives focus to the currently selected window

  Specified by:
    `windowFocus` in interface `Selenium`

### windowMaximize

    public void windowMaximize()

  Description copied from interface: `Selenium`
  Resize currently selected window to take up the entire screen

  Specified by:
    `windowMaximize` in interface `Selenium`

### getAllWindowIds

    public java.lang.String[] getAllWindowIds()

  Description copied from interface: `Selenium`
  Returns the IDs of all windows that the browser knows about.

  Specified by:
    `getAllWindowIds` in interface `Selenium`
  Returns:
    the IDs of all windows that the browser knows about.

### getAllWindowNames

    public java.lang.String[] getAllWindowNames()

  Description copied from interface: `Selenium`
  Returns the names of all windows that the browser knows about.

  Specified by:
    `getAllWindowNames` in interface `Selenium`
  Returns:
    the names of all windows that the browser knows about.

### getAllWindowTitles

    public java.lang.String[] getAllWindowTitles()

  Description copied from interface: `Selenium`
  Returns the titles of all windows that the browser knows about.

  Specified by:
    `getAllWindowTitles` in interface `Selenium`
  Returns:
    the titles of all windows that the browser knows about.

### getHtmlSource

    public java.lang.String getHtmlSource()

  Description copied from interface: `Selenium`
  Returns the entire HTML source between the opening and closing "html" tags.

  Specified by:
    `getHtmlSource` in interface `Selenium`
  Returns:
    the entire HTML source

### setCursorPosition

    public void setCursorPosition(java.lang.String locator,
                                  java.lang.String position)

  Description copied from interface: `Selenium`
  Moves the text cursor to the specified position in the given input element or textarea. This method will fail if the specified element isn't an input element or textarea.

  Specified by:
    `setCursorPosition` in interface `Selenium`
  Parameters:
    `locator` - an element locator pointing to an input element or textarea
    `position` - the numerical position of the cursor in the field; position should be 0 to move the position to the beginning of the field. You can also set the cursor to -1 to move it to the end of the field.

### getElementIndex

    public java.lang.Number getElementIndex(java.lang.String locator)

  Description copied from interface: `Selenium`
  Get the relative index of an element to its parent (starting from 0). The comment node and empty text node will be ignored.

  Specified by:
    `getElementIndex` in interface `Selenium`
  Parameters:
    `locator` - an element locator pointing to an element
  Returns:
    of relative index of the element to its parent (starting from 0)

### isOrdered

    public boolean isOrdered(java.lang.String locator1,
                             java.lang.String locator2)

  Description copied from interface: `Selenium`
  Check if these two elements have same parent and are ordered siblings in the DOM. Two same elements will not be considered ordered.

  Specified by:
    `isOrdered` in interface `Selenium`
  Parameters:
    `locator1` - an element locator pointing to the first element
    `locator2` - an element locator pointing to the second element
  Returns:
    true if element1 is the previous sibling of element2, false otherwise

### getElementPositionLeft

    public java.lang.Number getElementPositionLeft(java.lang.String locator)

  Description copied from interface: `Selenium`
  Retrieves the horizontal position of an element

  Specified by:
    `getElementPositionLeft` in interface `Selenium`
  Parameters:
    `locator` - an element locator pointing to an element OR an element itself
  Returns:
    of pixels from the edge of the frame.

### getElementPositionTop

    public java.lang.Number getElementPositionTop(java.lang.String locator)

  Description copied from interface: `Selenium`
  Retrieves the vertical position of an element

  Specified by:
    `getElementPositionTop` in interface `Selenium`
  Parameters:
    `locator` - an element locator pointing to an element OR an element itself
  Returns:
    of pixels from the edge of the frame.

### getElementWidth

    public java.lang.Number getElementWidth(java.lang.String locator)

  Description copied from interface: `Selenium`
  Retrieves the width of an element

  Specified by:
    `getElementWidth` in interface `Selenium`
  Parameters:
    `locator` - an element locator pointing to an element
  Returns:
    width of an element in pixels

### getElementHeight

    public java.lang.Number getElementHeight(java.lang.String locator)

  Description copied from interface: `Selenium`
  Retrieves the height of an element

  Specified by:
    `getElementHeight` in interface `Selenium`
  Parameters:
    `locator` - an element locator pointing to an element
  Returns:
    height of an element in pixels

### getCursorPosition

    public java.lang.Number getCursorPosition(java.lang.String locator)

  Description copied from interface: `Selenium`
  Retrieves the text cursor position in the given input element or textarea; beware, this may not work perfectly on all browsers.

  Specifically, if the cursor/selection has been cleared by JavaScript, this command will tend to return the position of the last location of the cursor, even though the cursor is now gone from the page. This is filed as SEL-243.

  This method will fail if the specified element isn't an input element or textarea, or there is no cursor in the element.

  Specified by:
    `getCursorPosition` in interface `Selenium`
  Parameters:
    `locator` - an element locator pointing to an input element or textarea
  Returns:
    the numerical position of the cursor in the field

### getExpression

    public java.lang.String getExpression(java.lang.String expression)

  Description copied from interface: `Selenium`
  Returns the specified expression.

  This is useful because of JavaScript preprocessing. It is used to generate commands like assertExpression and waitForExpression.

  Specified by:
    `getExpression` in interface `Selenium`
  Parameters:
    `expression` - the value to return
  Returns:
    the value passed in

### getXpathCount

    public java.lang.Number getXpathCount(java.lang.String xpath)

  Description copied from interface: `Selenium`
  Returns the number of nodes that match the specified xpath, eg. "//table" would give the number of tables.

  Specified by:
    `getXpathCount` in interface `Selenium`
  Parameters:
    `xpath` - the xpath expression to evaluate. do NOT wrap this expression in a 'count()' function; we will do that for you.
  Returns:
    the number of nodes that match the specified xpath

### assignId

    public void assignId(java.lang.String locator,
                         java.lang.String identifier)

  Description copied from interface: `Selenium`
  Temporarily sets the "id" attribute of the specified element, so you can locate it in the future using its ID rather than a slow/complicated XPath. This ID will disappear once the page is reloaded.

  Specified by:
    `assignId` in interface `Selenium`
  Parameters:
    `locator` - an element locator pointing to an element
    `identifier` - a string to be used as the ID of the specified element

### allowNativeXpath

    public void allowNativeXpath(java.lang.String allow)

  Description copied from interface: `Selenium`
  Specifies whether Selenium should use the native in-browser implementation of XPath (if any native version is available); if you pass "false" to this function, we will always use our pure-JavaScript xpath library. Using the pure-JS xpath library can improve the consistency of xpath element locators between different browser vendors, but the pure-JS version is much slower than the native implementations.

  Specified by:
    `allowNativeXpath` in interface `Selenium`
  Parameters:
    `allow` - boolean, true means we'll prefer to use native XPath; false means we'll only use JS XPath

### ignoreAttributesWithoutValue

    public void ignoreAttributesWithoutValue(java.lang.String ignore)

  Description copied from interface: `Selenium`
  Specifies whether Selenium will ignore xpath attributes that have no value, i.e. are the empty string, when using the non-native xpath evaluation engine. You'd want to do this for performance reasons in IE. However, this could break certain xpaths, for example an xpath that looks for an attribute whose value is NOT the empty string. The hope is that such xpaths are relatively rare, but the user should have the option of using them. Note that this only influences xpath evaluation when using the ajaxslt engine (i.e. not "javascript-xpath").

  Specified by:
    `ignoreAttributesWithoutValue` in interface `Selenium`
  Parameters:
    `ignore` - boolean, true means we'll ignore attributes without value at the expense of xpath "correctness"; false means we'll sacrifice speed for correctness.

### waitForCondition

    public void waitForCondition(java.lang.String script,
                                 java.lang.String timeout)

  Description copied from interface: `Selenium`
  Runs the specified JavaScript snippet repeatedly until it evaluates to "true". The snippet may have multiple lines, but only the result of the last line will be considered.

  Note that, by default, the snippet will be run in the runner's test window, not in the window of your application. To get the window of your application, you can use the JavaScript snippet `selenium.browserbot.getCurrentWindow()`, and then run your JavaScript in there

  Specified by:
    `waitForCondition` in interface `Selenium`
  Parameters:
    `script` - the JavaScript snippet to run
    `timeout` - a timeout in milliseconds, after which this command will return with an error

### setTimeout

    public void setTimeout(java.lang.String timeout)

  Description copied from interface: `Selenium`
  Specifies the amount of time that Selenium will wait for actions to complete.

  Actions that require waiting include "open" and the "waitFor*" actions.

  The default timeout is 30 seconds.

  Specified by:
    `setTimeout` in interface `Selenium`
  Parameters:
    `timeout` - a timeout in milliseconds, after which the action will return with an error

### waitForPageToLoad

    public void waitForPageToLoad(java.lang.String timeout)

  Description copied from interface: `Selenium`
  Waits for a new page to load.

  You can use this command instead of the "AndWait" suffixes, "clickAndWait", "selectAndWait", "typeAndWait" etc. (which are only available in the JS API).

  Selenium constantly keeps track of new pages loading, and sets a "newPageLoaded" flag when it first notices a page load. Running any other Selenium command after turns the flag to false. Hence, if you want to wait for a page to load, you must wait immediately after a Selenium command that caused a page-load.

  Specified by:
    `waitForPageToLoad` in interface `Selenium`
  Parameters:
    `timeout` - a timeout in milliseconds, after which this command will return with an error

### waitForFrameToLoad

    public void waitForFrameToLoad(java.lang.String frameAddress,
                                   java.lang.String timeout)

  Description copied from interface: `Selenium`
  Waits for a new frame to load.

  Selenium constantly keeps track of new pages and frames loading, and sets a "newPageLoaded" flag when it first notices a page load.

  See waitForPageToLoad for more information.

  Specified by:
    `waitForFrameToLoad` in interface `Selenium`
  Parameters:
    `frameAddress` - FrameAddress from the server side
    `timeout` - a timeout in milliseconds, after which this command will return with an error

### getCookie

    public java.lang.String getCookie()

  Description copied from interface: `Selenium`
  Return all cookies of the current page under test.

  Specified by:
    `getCookie` in interface `Selenium`
  Returns:
    all cookies of the current page under test

### getCookieByName

    public java.lang.String getCookieByName(java.lang.String name)

  Description copied from interface: `Selenium`
  Returns the value of the cookie with the specified name, or throws an error if the cookie is not present.

  Specified by:
    `getCookieByName` in interface `Selenium`
  Parameters:
    `name` - the name of the cookie
  Returns:
    the value of the cookie

### isCookiePresent

    public boolean isCookiePresent(java.lang.String name)

  Description copied from interface: `Selenium`
  Returns true if a cookie with the specified name is present, or false otherwise.

  Specified by:
    `isCookiePresent` in interface `Selenium`
  Parameters:
    `name` - the name of the cookie
  Returns:
    true if a cookie with the specified name is present, or false otherwise.

### createCookie

    public void createCookie(java.lang.String nameValuePair,
                             java.lang.String optionsString)

  Description copied from interface: `Selenium`
  Create a new cookie whose path and domain are same with those of current page under test, unless you specified a path for this cookie explicitly.

  Specified by:
    `createCookie` in interface `Selenium`
  Parameters:
    `nameValuePair` - name and value of the cookie in a format "name=value"
    `optionsString` - options for the cookie. Currently supported options include 'path', 'max_age' and 'domain'. the optionsString's format is "path=/path/, max_age=60, domain=.foo.com". The order of options are irrelevant, the unit of the value of 'max_age' is second. Note that specifying a domain that isn't a subset of the current domain will usually fail.

### deleteCookie

    public void deleteCookie(java.lang.String name,
                             java.lang.String optionsString)

  Description copied from interface: `Selenium`
  Delete a named cookie with specified path and domain. Be careful; to delete a cookie, you need to delete it using the exact same path and domain that were used to create the cookie. If the path is wrong, or the domain is wrong, the cookie simply won't be deleted. Also note that specifying a domain that isn't a subset of the current domain will usually fail. Since there's no way to discover at runtime the original path and domain of a given cookie, we've added an option called 'recurse' to try all sub-domains of the current domain with all paths that are a subset of the current path. Beware; this option can be slow. In big-O notation, it operates in O(n*m) time, where n is the number of dots in the domain name and m is the number of slashes in the path.

  Specified by:
    `deleteCookie` in interface `Selenium`
  Parameters:
    `name` - the name of the cookie to be deleted
    `optionsString` - options for the cookie. Currently supported options include 'path', 'domain' and 'recurse.' The optionsString's format is "path=/path/, domain=.foo.com, recurse=true". The order of options are irrelevant. Note that specifying a domain that isn't a subset of the current domain will usually fail.

### deleteAllVisibleCookies

    public void deleteAllVisibleCookies()

  Description copied from interface: `Selenium`
  Calls deleteCookie with recurse=true on all cookies visible to the current page. As noted on the documentation for deleteCookie, recurse=true can be much slower than simply deleting the cookies using a known domain/path.

  Specified by:
    `deleteAllVisibleCookies` in interface `Selenium`

### setBrowserLogLevel

    public void setBrowserLogLevel(java.lang.String logLevel)

  Description copied from interface: `Selenium`
  Sets the threshold for browser-side logging messages; log messages beneath this threshold will be discarded. Valid logLevel strings are: "debug", "info", "warn", "error" or "off". To see the browser logs, you need to either show the log window in GUI mode, or enable browser-side logging in Selenium RC.

  Specified by:
    `setBrowserLogLevel` in interface `Selenium`
  Parameters:
    `logLevel` - one of the following: "debug", "info", "warn", "error" or "off"

### runScript

    public void runScript(java.lang.String script)

  Description copied from interface: `Selenium`
  Creates a new "script" tag in the body of the current test window, and adds the specified text into the body of the command. Scripts run in this way can often be debugged more easily than scripts executed using Selenium's "getEval" command. Beware that JS exceptions thrown in these script tags aren't managed by Selenium, so you should probably wrap your script in try/catch blocks if there is any chance that the script will throw an exception.

  Specified by:
    `runScript` in interface `Selenium`
  Parameters:
    `script` - the JavaScript snippet to run

### addLocationStrategy

    public void addLocationStrategy(java.lang.String strategyName,
                                    java.lang.String functionDefinition)

  Description copied from interface: `Selenium`
  Defines a new function for Selenium to locate elements on the page. For example, if you define the strategy "foo", and someone runs click("foo=blah"), we'll run your function, passing you the string "blah", and click on the element that your function returns, or throw an "Element not found" error if your function returns null. We'll pass three arguments to your function:
  - locator: the string the user passed in
  - inWindow: the currently selected window
  - inDocument: the currently selected document
  The function must return null if the element can't be found.

  Specified by:
    `addLocationStrategy` in interface `Selenium`
  Parameters:
    `strategyName` - the name of the strategy to define; this should use only letters [a-zA-Z] with no spaces or other punctuation.
    `functionDefinition` - a string defining the body of a function in JavaScript. For example: `return inDocument.getElementById(locator);`

### captureEntirePageScreenshot

    public void captureEntirePageScreenshot(java.lang.String filename,
                                            java.lang.String kwargs)

  Description copied from interface: `Selenium`
  Saves the entire contents of the current window canvas to a PNG file. Contrast this with the captureScreenshot command, which captures the contents of the OS viewport (i.e. whatever is currently being displayed on the monitor), and is implemented in the RC only. Currently this only works in Firefox when running in chrome mode, and in IE non-HTA using the EXPERIMENTAL "Snapsie" utility. The Firefox implementation is mostly borrowed from the Screengrab! Firefox extension. Please see http://www.screengrab.org and http://snapsie.sourceforge.net/ for details.

  Specified by:
    `captureEntirePageScreenshot` in interface `Selenium`
  Parameters:
    `filename` - the path to the file to persist the screenshot as. No filename extension will be appended by default. Directories will not be created if they do not exist, and an exception will be thrown, possibly by native code.
    `kwargs` - a kwargs string that modifies the way the screenshot is captured. Example: "background=#CCFFDD" . Currently valid options:
    background
      the background CSS for the HTML document. This may be useful to set for capturing screenshots of less-than-ideal layouts, for example where absolute positioning causes the calculation of the canvas dimension to fail and a black background is exposed (possibly obscuring black text).

### rollup

    public void rollup(java.lang.String rollupName,
                       java.lang.String kwargs)

  Description copied from interface: `Selenium`
  Executes a command rollup, which is a series of commands with a unique name, and optionally arguments that control the generation of the set of commands. If any one of the rolled-up commands fails, the rollup is considered to have failed. Rollups may also contain nested rollups.

  Specified by:
    `rollup` in interface `Selenium`
  Parameters:
    `rollupName` - the name of the rollup command
    `kwargs` - keyword arguments string that influences how the rollup expands into commands

### addScript

    public void addScript(java.lang.String scriptContent,
                          java.lang.String scriptTagId)

  Description copied from interface: `Selenium`
  Loads script content into a new script tag in the Selenium document. This differs from the runScript command in that runScript adds the script tag to the document of the AUT, not the Selenium document. The following entities in the script content are replaced by the characters they represent: < > & The corresponding remove command is removeScript.

  Specified by:
    `addScript` in interface `Selenium`
  Parameters:
    `scriptContent` - the Javascript content of the script to add
    `scriptTagId` - (optional) the id of the new script tag. If specified, and an element with this id already exists, this operation will fail.

### removeScript

    public void removeScript(java.lang.String scriptTagId)

  Description copied from interface: `Selenium`
  Removes a script tag from the Selenium document identified by the given id. Does nothing if the referenced tag doesn't exist.

  Specified by:
    `removeScript` in interface `Selenium`
  Parameters:
    `scriptTagId` - the id of the script element to remove.

### useXpathLibrary

    public void useXpathLibrary(java.lang.String libraryName)

  Description copied from interface: `Selenium`
  Allows choice of one of the available libraries.

  Specified by:
    `useXpathLibrary` in interface `Selenium`
  Parameters:
    `libraryName` - name of the desired library Only the following three can be chosen:
    - "ajaxslt" - Google's library
    - "javascript-xpath" - Cybozu Labs' faster library
    - "default" - The default library. Currently the default library is "ajaxslt" .
    If libraryName isn't one of these three, then no change will be made.

### setContext

    public void setContext(java.lang.String context)

  Description copied from interface: `Selenium`
  Writes a message to the status bar and adds a note to the browser-side log.

  Specified by:
    `setContext` in interface `Selenium`
  Parameters:
    `context` - the message to be sent to the browser

### attachFile

    public void attachFile(java.lang.String fieldLocator,
                           java.lang.String fileLocator)

  Description copied from interface: `Selenium`
  Sets a file input (upload) field to the file listed in fileLocator

  Specified by:
    `attachFile` in interface `Selenium`
  Parameters:
    `fieldLocator` - an element locator
    `fileLocator` - a URL pointing to the specified file. Before the file can be set in the input field (fieldLocator), Selenium RC may need to transfer the file to the local machine before attaching the file in a web page form. This is common in selenium grid configurations where the RC server driving the browser is not the same machine that started the test. Supported Browsers: Firefox ("*chrome") only.

### captureScreenshot

    public void captureScreenshot(java.lang.String filename)

  Description copied from interface: `Selenium`
  Captures a PNG screenshot to the specified file.

  Specified by:
    `captureScreenshot` in interface `Selenium`
  Parameters:
    `filename` - the absolute path to the file to be written, e.g. "c:\blah\screenshot.png"

### captureScreenshotToString

    public java.lang.String captureScreenshotToString()

  Description copied from interface: `Selenium`
  Capture a PNG screenshot. It then returns the file as a base 64 encoded string.

  Specified by:
    `captureScreenshotToString` in interface `Selenium`
  Returns:
    The base 64 encoded string of the screen shot (PNG file)

### captureNetworkTraffic

    public java.lang.String captureNetworkTraffic(java.lang.String type)

  Description copied from interface: `Selenium`
  Returns the network traffic seen by the browser, including headers, AJAX requests, status codes, and timings. When this function is called, the traffic log is cleared, so the returned content is only the traffic seen since the last call.

  Specified by:
    `captureNetworkTraffic` in interface `Selenium`
  Parameters:
    `type` - The type of data to return the network traffic as. Valid values are: json, xml, or plain.
  Returns:
    A string representation in the defined type of the network traffic seen by the browser.

### addCustomRequestHeader

    public void addCustomRequestHeader(java.lang.String key,
                                       java.lang.String value)

  Description copied from interface: `Selenium`
  Tells the Selenium server to add the specificed key and value as a custom outgoing request header. This only works if the browser is configured to use the built in Selenium proxy.

  Specified by:
    `addCustomRequestHeader` in interface `Selenium`
  Parameters:
    `key` - the header name.
    `value` - the header value.

### captureEntirePageScreenshotToString

    public java.lang.String captureEntirePageScreenshotToString(java.lang.String kwargs)

  Description copied from interface: `Selenium`
  Downloads a screenshot of the browser current window canvas to a based 64 encoded PNG file. The entire windows canvas is captured, including parts rendered outside of the current view port. Currently this only works in Mozilla and when running in chrome mode.

  Specified by:
    `captureEntirePageScreenshotToString` in interface `Selenium`
  Parameters:
    `kwargs` - A kwargs string that modifies the way the screenshot is captured. Example: "background=#CCFFDD". This may be useful to set for capturing screenshots of less-than-ideal layouts, for example where absolute positioning causes the calculation of the canvas dimension to fail and a black background is exposed (possibly obscuring black text).
  Returns:
    The base 64 encoded string of the page screenshot (PNG file)

### shutDownSeleniumServer

    public void shutDownSeleniumServer()

  Description copied from interface: `Selenium`
  Kills the running Selenium Server and all browser sessions. After you run this command, you will no longer be able to send commands to the server; you can't remotely start the server once it has been stopped. Normally you should prefer to run the "stop" command, which terminates the current browser session, rather than shutting down the entire server.

  Specified by:
    `shutDownSeleniumServer` in interface `Selenium`

### retrieveLastRemoteControlLogs

    public java.lang.String retrieveLastRemoteControlLogs()

  Description copied from interface: `Selenium`
  Retrieve the last messages logged on a specific remote control. Useful for error reports, especially when running multiple remote controls in a distributed environment. The maximum number of log messages that can be retrieve is configured on remote control startup.

  Specified by:
    `retrieveLastRemoteControlLogs` in interface `Selenium`
  Returns:
    The last N log messages as a multi-line string.

### keyDownNative

    public void keyDownNative(java.lang.String keycode)

  Description copied from interface: `Selenium`
  Simulates a user pressing a key (without releasing it yet) by sending a native operating system keystroke. This function uses the java.awt.Robot class to send a keystroke; this more accurately simulates typing a key on the keyboard. It does not honor settings from the shiftKeyDown, controlKeyDown, altKeyDown and metaKeyDown commands, and does not target any particular HTML element. To send a keystroke to a particular element, focus on the element first before running this command.

  Specified by:
    `keyDownNative` in interface `Selenium`
  Parameters:
    `keycode` - an integer keycode number corresponding to a java.awt.event.KeyEvent; note that Java keycodes are NOT the same thing as JavaScript keycodes!

### keyUpNative

    public void keyUpNative(java.lang.String keycode)

  Description copied from interface: `Selenium`
  Simulates a user releasing a key by sending a native operating system keystroke. This function uses the java.awt.Robot class to send a keystroke; this more accurately simulates typing a key on the keyboard. It does not honor settings from the shiftKeyDown, controlKeyDown, altKeyDown and metaKeyDown commands, and does not target any particular HTML element. To send a keystroke to a particular element, focus on the element first before running this command.

  Specified by:
    `keyUpNative` in interface `Selenium`
  Parameters:
    `keycode` - an integer keycode number corresponding to a java.awt.event.KeyEvent; note that Java keycodes are NOT the same thing as JavaScript keycodes!

### keyPressNative

    public void keyPressNative(java.lang.String keycode)

  Description copied from interface: `Selenium`
  Simulates a user pressing and releasing a key by sending a native operating system keystroke. This function uses the java.awt.Robot class to send a keystroke; this more accurately simulates typing a key on the keyboard. It does not honor settings from the shiftKeyDown, controlKeyDown, altKeyDown and metaKeyDown commands, and does not target any particular HTML element. To send a keystroke to a particular element, focus on the element first before running this command.

  Specified by:
    `keyPressNative` in interface `Selenium`
  Parameters:
    `keycode` - an integer keycode number corresponding to a java.awt.event.KeyEvent; note that Java keycodes are NOT the same thing as JavaScript keycodes!

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2009. All Rights Reserved.